#!/usr/bin/env python
"""
See pcolor_demo2 for an alternative way of generating pcolor plots
using imshow that is likely faster for large grids
"""
#from __future__ import division
from matplotlib.patches import Patch
from matplotlib.patches import Ellipse
from pylab import *
from scipy.ndimage import zoom
import os




# make these smaller to increase the resolution
dx, dy = 0.01, 0.01


fig, ax = plt.subplots()

x=[];
y=[];


if os.path.exists("./outputovi/FAM_output/strength_fam.dat"):
    FILE = open('./outputovi/FAM_output/strength_fam.dat','r');
else:
    FILE = open('./strength_fam.dat','r');

##################################################################################################
Naslov = '';

FILE.readline();
FILE.readline();

tmp = FILE.readline();
jezgra = tmp.split()[0]
A = '';
i = 0;
while True:
    if jezgra[i].isdigit() == False:
        break;
    A += jezgra[i];
    i += 1;
if jezgra[i] == '_' :
    i += 1;
Ime_jezgre = jezgra[i:][:-1];
Naslov += ' ${}^{' + A + '}$' + '$\\mathrm{'+Ime_jezgre+'}$'  + '\n $\\bullet$ $' + tmp.split()[1]+'$ $\\mathrm{shells}$ ' + '\n $\\bullet$ ';

tmp = FILE.readline();
Naslov += '$\\mathrm{' + tmp.split()[0] + '}$ $\\mathrm{' + tmp.split()[1] + '}$\n $\\bullet$ ';
tmp = FILE.readline();
Naslov += '$\\mathrm{' + tmp.split()[0] + '}$ $\\mathrm{' + tmp.split()[1] + '}$\n $\\bullet$ ';

tmp = FILE.readline();
ISO = '$\\mathrm{'+(tmp.split()[0]).capitalize()+'}$';

tmp = FILE.readline();
tmp2 = FILE.readline();
Naslov += ISO + '$,$ $J =  ' + tmp.split()[2] + ', K = ' + tmp2.split()[2] + '$\n $\\bullet$ ';
K_multipol = int(float(tmp2.split()[2]));
J_multipol = int(float(tmp.split()[2]));
tmp2 = FILE.readline();
Naslov += '$\\gamma = ' + \
          str(float( tmp2.split()[2] )) + '$ $\\mathrm{[MeV]}$ ' + '\n $\\bullet$ ';
tmp = FILE.readline();
Naslov += '$\\mathrm{N_{GH} =}$$' + tmp.split()[2] + '$ $\\mathrm{N_{GL} =}$$' + tmp.split()[5] + '$'; 

FILE.readline();
FILE.readline();
FILE.readline();

predznak = 1-2*(K_multipol%2);


mjerna_jedinica = '$\\mathrm{[fm}^' + str(2*(1+(J_multipol-1)**2)) + '\\mathrm{/MeV]}$';

##################################################################################################


for string in FILE:        
    s1= float( string.split()[0] )
    s2= float( string.split()[1] )
    x.append( s1 )
    y.append( s2 )
    
x,y = (list(t) for t in zip(*sorted(zip(x,y))))


FILE.close()

figure(1)
ax.plot(x,y, '-' , color='blue' );
ax.plot(x,y, 'o', ms=5, lw=2, alpha=0.9, mfc='orange');


ax.set_xlim( min(x)*0.95 , max(x)*1.05 )
ax.set_ylim( min(y)*0.95 , max(y)*1.05 )

ax.set_xlabel( '$\\hbar\\omega$'+' $ \\mathrm{ [MeV]}$' , fontsize=16 )
ax.set_ylabel( '$\\frac{dB(\hat{f},\\omega)}{d\\omega}$ ' + mjerna_jedinica , fontsize=16 );
#plt.ticklabel_format(style='sci', axis='y', scilimits=(0,0))
props = dict(boxstyle='round', facecolor='wheat', alpha=0.5)
ax.text(0.65, 0.95, Naslov, ha="left", va="top", fontsize=10 , bbox=props, transform = ax.transAxes )

plt.fill_between(x,y,color='blue',alpha=0.05,label=r'$K^\pi=0^-$')
#plt.grid();


if os.path.exists("./outputovi/FAM_output/"):
    fig.savefig("./outputovi/FAM_output/strength_plot.pdf", bbox_inches='tight')
else:
    fig.savefig("strength_plot.pdf", bbox_inches='tight')
    

show()


