c======================================================================c

      subroutine print_denscurr( lpr )

c======================================================================c

      implicit real*8 (a-h,o-z)
      include 'dirhb.par'
      logical lpr;

      common /gaussh/ xh(0:NGH), wh(0:NGH), zb(0:NGH);
      common /gaussl/ xl(0:NGL), wl(0:NGL), sxl(0:NGL), rb(0:NGL);

      common /fam/ omega_start, omega_end, delta_omega, omega,
     &             gamma_smear, omega_trans_dens,
     &             i_Hartree_response,
     &             J_multipole, K_multipole,
     &             ISO, fac_iso(2);

      COMPLEX*16 drho_v;
      COMPLEX*16 drho_s;
      COMPLEX*16 ldrho_v;
      COMPLEX*16 ldrho_s;
      common /ind_dens/ drho_v ( -NGH:NGH , 1:NGL , 2 ),
     &                  drho_s ( -NGH:NGH , 1:NGL , 2 ),
     &                  ldrho_v( -NGH:NGH , 1:NGL , 2 ),
     &                  ldrho_s( -NGH:NGH , 1:NGL , 2 );



      if(lpr) then
      write(6,*) '';
      write(6,*) '****** BEGIN printdens_curr() ***********************';
      write(6,*) '';
      endif



      open( 200 , file = './output/FAM_output/drho_v.dat' ,
     &      status = 'unknown' );



      write(200,'(a,a,a,i1,a)')
     &          'drho_v(r,z,phi) = ',
     &          'drho_v(r,z) ',
     &          '* cos(',K_multipole,'*phi)';

      call print_header( 200 );

      write(200,'(a,1f7.3,a)') 'omega = ', omega,
     &                         ' [MeV/hbar]';
      write(200,*) '';
      write(200,*) '';
      write(200,*) '       r[fm]             ',
     &             '       z[fm]             ',
     &             '                 ',
     &             'drho_v(r,z) [fm^-3]';
      write(200,*) '';


c
      do il = 1 , NGL
          do ih = -NGH , NGH
              if( ih .eq. 0 ) CYCLE;

              write(200,'(1f20.12,1f25.12,E30.12,a,E22.12,a)')
     &                  rb(il), DBLE(isign(1,ih))*zb(abs(ih)),
     &                  DREAL( drho_v(ih,il,1)+drho_v(ih,il,2) ),
     &                  '   +',
     &                  DIMAG( drho_v(ih,il,1)+drho_v(ih,il,2) ),
     &                  ' i';
          enddo
      enddo


      close(200);



      if(lpr) then
      write(6,*) '';
      write(6,*) '****** END print_denscurr() *************************';
      write(6,*) '';
      endif

      return;
      end;






c======================================================================c

      subroutine print_header( tape )

c======================================================================c

      implicit real*8 (a-h,o-z)
      include 'dirhb.par'
      INTEGER tape;

      CHARACTER parname*10;
      common /partyp/ parname;
      
      common /basnnn/ n0f, n0b;

      CHARACTER*2 nucnam;
      common /nucnuc/ amas, nneu, npro, nmas, nucnam;

      common /fam_flags/ i_coulomb, i_pairing;

      common /fam/ omega_start, omega_end, delta_omega, omega,
     &             gamma_smear, omega_trans_dens,
     &             i_Hartree_response,
     &             J_multipole, K_multipole,
     &             ISO, fac_iso(2);






      if( i_Hartree_response .eq. 1 ) then
          write(tape,'(a)') 'Hartree response';
      else
          write(tape,'(a)') 'Full self-consistent response';
      endif
            
      write(tape,'(i3,a,a,i2,a,a)') nmas, nucnam, ', ', n0f, 
     &                            ' shells, ', parname;
      
      if( i_coulomb .eq. 1 ) then
          write(tape,'(a)') 'Electromagnetism included in calculation';
      else
          write(tape,'(a)') 'Electromagnetism excluded from calculation';
      endif
      
      if( i_pairing .eq. 1 ) then
          write(tape,'(a)') 'Pairing included in calculation';
      else
          write(tape,'(a)') 'Pairing excluded from calculation';
      endif
      
      if( ISO .eq. 0 ) then
          write(tape,'(a)') 'Isoscalar excitation';    
      else
          write(tape,'(a)') 'Isovector excitation';
      endif
      
      write(tape,'(a,i1)') 'J = ', J_multipole;
      write(tape,'(a,i1)') 'K = ', K_multipole;
      write(tape,'(a,1f7.3,a)') 'gamma_smear = ', gamma_smear,
     &                          ' [MeV/hbar]   ';
      write(tape,'(a,i2,a,i2)') 'NGH = ', NGH, ', NGL = ', NGL;



      return;
      end;
