c======================================================================c

      subroutine start_fam( lpr )

c======================================================================c

      implicit real*8 (a-h,o-z)
      include 'dirhb.par'
      logical lpr;

      common /fam_flags/ i_coulomb, i_pairing;

      common /fam/ omega_start, omega_end, delta_omega, omega,
     &             gamma_smear, omega_trans_dens,
     &             i_Hartree_response,
     &             J_multipole, K_multipole,
     &             ISO, fac_iso(2);

      COMPLEX*16 dh_1, dh_2;
      common /delta_h/ dh_1( NTX , NTX , 2 ),
     &                 dh_2( NTX , NTX , 2 );

      COMPLEX*16 dDelta_pl, dDelta_mi;
      common /dDelta/ dDelta_pl( NTX , NTX , 2 ),
     &                dDelta_mi( NTX , NTX , 2 );



      if(lpr) then
      write(6,*) '';
      write(6,*) '****** BEGIN start_fam() ***************************';
      write(6,*) '';
      endif







c-----Printing strength_fam.dat
      open( 100 , file   = './output/FAM_output/strength_fam.dat' ,
     &            status = 'unknown' );

      if(      J_multipole .eq. 0 ) then
          write(100,*) 'S(f,omega) = -Im[Tr[f*delta_rho]]/pi [fm^4/MeV]';
      else if( J_multipole .eq. 1 ) then
          write(100,*) 'S(f,omega) = -Im[Tr[f*delta_rho]]/pi [fm^2/MeV]';
      else if( J_multipole .eq. 2 ) then
          write(100,*) 'S(f,omega) = -Im[Tr[f*delta_rho]]/pi [fm^4/MeV]';
      else if( J_multipole .eq. 3 ) then
          write(100,*) 'S(f,omega) = -Im[Tr[f*delta_rho]]/pi [fm^6/MeV]';
      else
          stop 'Error: J_multipole > 3 not implemented!';
      endif

      call print_header( 100 );

      write(100,*) '';
      write(100,*) 'omega[MeV/hbar]       ',
     &             'Sp(f,omega)+Sn(f,omega)          ',
     &             'Sn(f,omega)          ',
     &             'Sp(f,omega)';
      write(100,*) '';

      if( i_Hartree_response .eq. 1 ) then
              write(6,*) '                          ',
     &                   '          Hartree response';
              write(6,*) '';
              write(6,*) 'omega[MeV/hbar]       ',
     &                   'Sp(f,omega)+Sn(f,omega)          ',
     &                   'Sn(f,omega)          ',
     &                   'Sp(f,omega)';

      endif






c-----Hartree response
      if( i_Hartree_response .eq. 1 ) then

          dh_1      = COMPLEX( 0.D0 , 0.D0 );
          dh_2      = COMPLEX( 0.D0 , 0.D0 );
          dDelta_pl = COMPLEX( 0.D0 , 0.D0 );
          dDelta_mi = COMPLEX( 0.D0 , 0.D0 );
          Smax       = -1.D0;
          omega_peak = omega_start;

          omega = omega_start;
          do while( omega .le. omega_end+1.D-4 )

              call fam_drhodkappa( .false. , 1 );
              call fam_drhodkappa( .false. , 2 );

              Sn = strength( .false. , 1 );
              Sp = strength( .false. , 2 );

              if( Sn+Sp .gt. Smax ) then
                  omega_peak = omega;
                  Smax       = Sn+Sp;
              endif

              write(6,'(1f15.5,1f31.10,1f21.10,1f21.10)')
     &              omega , Sp+Sn , Sn , Sp;
              write(100,'(1f15.5,1f31.10,1f21.10,1f21.10)')
     &              omega , Sp+Sn , Sn , Sp;
              flush(100);

              omega = omega + delta_omega;
          enddo



          omega = omega_trans_dens;
          if( omega_trans_dens .eq. 0.D0 ) then
              omega = omega_peak;
          endif

          dh_1      = COMPLEX( 0.D0 , 0.D0 );
          dh_2      = COMPLEX( 0.D0 , 0.D0 );
          dDelta_pl = COMPLEX( 0.D0 , 0.D0 );
          dDelta_mi = COMPLEX( 0.D0 , 0.D0 );
          call fam_drhodkappa( .false. , 1 );
          call fam_drhodkappa( .false. , 2 );
          call fam_ddensdcurr( .false. );
          call print_denscurr( .false. );

      endif






c-----Full self-consistent response
      if( i_Hartree_response .ne. 1 ) then

          dh_1      = COMPLEX( 0.D0 , 0.D0 );
          dh_2      = COMPLEX( 0.D0 , 0.D0 );
          dDelta_pl = COMPLEX( 0.D0 , 0.D0 );
          dDelta_mi = COMPLEX( 0.D0 , 0.D0 );
          Smax       = -1.D0;
          omega_peak = omega_start;


          ! One can easily parallelize this loop over omega
          omega = omega_start;
          do while( omega .le. omega_end + 1.D-4 )

              call iter_fam( .false. );
              Sn = strength( .false. , 1 );
              Sp = strength( .false. , 2 );

              if( Sn+Sp .gt. Smax ) then
                  omega_peak = omega;
                  Smax       = Sn+Sp;
              endif

              write(100,'(1f15.5,1f31.10,1f21.10,1f21.10)')
     &              omega , Sp+Sn , Sn , Sp;
              call flush(100);

              omega = omega + delta_omega;
          enddo




          if( omega_trans_dens .eq. 0.D0 ) then
              omega = omega_peak;
          else
              omega = omega_trans_dens;
          endif

          dh_1      = COMPLEX( 0.D0 , 0.D0 );
          dh_2      = COMPLEX( 0.D0 , 0.D0 );
          dDelta_pl = COMPLEX( 0.D0 , 0.D0 );
          dDelta_mi = COMPLEX( 0.D0 , 0.D0 );
          call iter_fam( .false. );
          call print_denscurr( .false. );

      endif



      close(100);


      if(lpr) then
      write(6,*) '';
      write(6,*) '****** END start_fam() *****************************';
      write(6,*) '';
      endif

      return;
      end;
